<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Cus01600DesvioDeConsumoController extends \Zeedhi\Framework\Controller\Report {

    protected $nrorg;
    protected $cdfilial;
    protected $consplan;
    protected $repParam;
    protected $novoCodigo;
    protected $nrConsPlan;
    protected $environment;
    protected $qr2Strategy;
    protected $procedureConsplanGeral;
    protected $cus01600DesvioDeConsumoService;
    protected $birtStrategy;

    public function __construct(ReportService $reportService, $novoCodigo, $consplan, $qr2Strategy, $servicoPorGrupo, StoredProcedure $procedureConsplanGeral, $environment, $cus01600DesvioDeConsumoService, $util, $connection, $birtStrategy) {

        $this->util                            = $util;
        $this->consplan                        = $consplan;        
        $this->connection                      = $connection;
        $this->novoCodigo                      = $novoCodigo;
        $this->qr2Strategy                     = $qr2Strategy;
        $this->environment                     = $environment;
        $this->reportService                   = $reportService;
        $this->servicoPorGrupo                 = $servicoPorGrupo;
        $this->procedureConsplanGeral          = $procedureConsplanGeral;
        $this->cus01600DesvioDeConsumoService  = $cus01600DesvioDeConsumoService;
        $this->birtStrategy = $birtStrategy;
    }
    
    protected $reportMapping = array(
        'cus01600' => array(
            'strategy' => 'BIRT',
            'parameterMapping'  => array(
                'LISTAFILI'     => 'L_FILIAL',
                'DTMESINIC'     => 'P_DTMESINIC',
                'DTMESFINA'     => 'P_DTMESFINA',
                'DTINICIAL'     => 'P_DTINICIAL',
                'DTFINAL'       => 'P_DTFINAL',
                'NRTIPOCUSTO'   => 'P_NRTIPOCUSTO',
                'CDGRUPSERV'    => 'P_CDGRUPSERV',
                'LISTASERV'     => 'L_SERVICO',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                'CDPRODINIC'    => 'P_CDPRODINIC',
                'CDPRODFINA'    => 'P_CDPRODFINA',
                'IDESTOCAVEIS'  => 'P_IDESTOCAVEIS',
                'IDNESTOCAVEIS' => 'P_IDNESTOCAVEIS',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NMCUSTO'       => 'P_NMCUSTO',
                'NRORG'         => 'P_NRORG',
                'IDDIFERENCA'   => 'P_IDDIFERENCA',
                'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA'
            )
        ),
        'cus01601' => array(
            'strategy' => 'BIRT',
            'parameterMapping'  => array(
                'LISTAFILI'     => 'L_FILIAL',
                'DTMESINIC'     => 'P_DTMESINIC',
                'DTMESFINA'     => 'P_DTMESFINA',
                'DTINICIAL'     => 'P_DTINICIAL',
                'DTFINAL'       => 'P_DTFINAL',
                'NRTIPOCUSTO'   => 'P_NRTIPOCUSTO',
                'CDGRUPSERV'    => 'P_CDGRUPSERV',
                'LISTASERV'     => 'L_SERVICO',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                'CDPRODINIC'    => 'P_CDPRODINIC',
                'CDPRODFINA'    => 'P_CDPRODFINA',
                'IDESTOCAVEIS'  => 'P_IDESTOCAVEIS',
                'IDNESTOCAVEIS' => 'P_IDNESTOCAVEIS',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NMCUSTO'       => 'P_NMCUSTO',
                'NRORG'         => 'P_NRORG',
                'IDDIFERENCA'   => 'P_IDDIFERENCA',
                'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA'
            )
        ),
        'cus01602' => array(
            'strategy' => 'BIRT',
            'parameterMapping'  => array(
                'LISTAFILI'     => 'L_FILIAL',
                'DTMESINIC'     => 'P_DTMESINIC',
                'DTMESFINA'     => 'P_DTMESFINA',
                'DTINICIAL'     => 'P_DTINICIAL',
                'DTFINAL'       => 'P_DTFINAL',
                'NRTIPOCUSTO'   => 'P_NRTIPOCUSTO',
                'CDGRUPSERV'    => 'P_CDGRUPSERV',
                'LISTASERV'     => 'L_SERVICO',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                'CDPRODINIC'    => 'P_CDPRODINIC',
                'CDPRODFINA'    => 'P_CDPRODFINA',
                'IDESTOCAVEIS'  => 'P_IDESTOCAVEIS',
                'IDNESTOCAVEIS' => 'P_IDNESTOCAVEIS',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NMCUSTO'       => 'P_NMCUSTO',
                'NRORG'         => 'P_NRORG',
                'IDDIFERENCA'   => 'P_IDDIFERENCA'
            )
        ),
        'cus01603' => array(
            'strategy' => 'BIRT',
            'parameterMapping'  => array(
                'LISTAFILI'     => 'L_FILIAL',
                'DTMESINIC'     => 'P_DTMESINIC',
                'DTMESFINA'     => 'P_DTMESFINA',
                'DTINICIAL'     => 'P_DTINICIAL',
                'DTFINAL'       => 'P_DTFINAL',
                'NRTIPOCUSTO'   => 'P_NRTIPOCUSTO',
                'CDGRUPSERV'    => 'P_CDGRUPSERV',
                'LISTASERV'     => 'L_SERVICO',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                'CDPRODINIC'    => 'P_CDPRODINIC',
                'CDPRODFINA'    => 'P_CDPRODFINA',
                'IDESTOCAVEIS'  => 'P_IDESTOCAVEIS',
                'IDNESTOCAVEIS' => 'P_IDNESTOCAVEIS',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NMCUSTO'       => 'P_NMCUSTO',
                'NRORG'         => 'P_NRORG',
                'IDDIFERENCA'   => 'P_IDDIFERENCA',
                'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA'
            )
        ),
        'cus01604' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'LISTAFILI'     => 'L_FILIAL',
                'DTMESINIC'     => 'P_DTMESINIC',
                'DTMESFINA'     => 'P_DTMESFINA',
                'DTINICIAL'     => 'P_DTINICIAL',
                'DTFINAL'       => 'P_DTFINAL',
                'NRTIPOCUSTO'   => 'P_NRTIPOCUSTO',
                'CDGRUPSERV'    => 'P_CDGRUPSERV',
                'LISTASERV'     => 'L_SERVICO',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                'CDPRODINIC'    => 'P_CDPRODINIC',
                'CDPRODFINA'    => 'P_CDPRODFINA',
                'IDESTOCAVEIS'  => 'P_IDESTOCAVEIS',
                'IDNESTOCAVEIS' => 'P_IDNESTOCAVEIS',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NMCUSTO'       => 'P_NMCUSTO',
                'NRORG'         => 'P_NRORG',
                'IDDIFERENCA'   => 'P_IDDIFERENCA'
            )
        ),
        'cus01605' => array(
            'strategy' => 'QR2',
            'parameterMapping'  => array(
                'LISTAFILI'     => 'L_FILIAL',
                'DTMESINIC'     => 'P_DTMESINIC',
                'DTMESFINA'     => 'P_DTMESFINA',
                'DTINICIAL'     => 'P_DTINICIAL',
                'DTFINAL'       => 'P_DTFINAL',
                'NRTIPOCUSTO'   => 'P_NRTIPOCUSTO',
                'CDGRUPSERV'    => 'P_CDGRUPSERV',
                'LISTASERV'     => 'L_SERVICO',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'  => 'P_NRTAMACNIVEL',
                'CDPRODINIC'    => 'P_CDPRODINIC',
                'CDPRODFINA'    => 'P_CDPRODFINA',
                'IDESTOCAVEIS'  => 'P_IDESTOCAVEIS',
                'IDNESTOCAVEIS' => 'P_IDNESTOCAVEIS',
                'NRCONSPLAN'    => 'P_NRCONSPLAN',
                'CDPICTPROD'    => 'P_CDPICTPROD',
                'NMCUSTO'       => 'P_NMCUSTO',
                'NRORG'         => 'P_NRORG',
                'IDDIFERENCA'   => 'P_IDDIFERENCA'
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        /*
        O erro "error fetching http headers" é causado 
        pelo tempo de espera muito curto na maquina local
        A função ini_set com parâmetro de 'default_socket_timeout' 
        aumenta o tempo limite da requisição.
        (segundo parâmentro em segundos)

        ini_set('default_socket_timeout', 10000); */

        $row = $request->getRow();
        
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $cdfilial            = $this->environment->getCdFilial();
        $dtInicial           = $row['DTINICIAL'];
        $dtFinal             = $row['DTFINAL'];
        $nrConsPlan          = $this->novoCodigo->getCodeByTableName('CONSPLAN'.$cdfilial, $this->environment->getNrOrg());
        $idArredond          = "N";
        $idProdutos          = "CFP";
        $cdOperador          = $this->environment->getCdOperador();
        $idSepPratos         = "P";
        $peAcrescimo         = 0;
        $cdProdutoIni        = $row['CDPRODINIC'];
        $row['CDPRODFINA']   = str_pad($row['CDPRODFINA'], 10 , "z"); 
        $cdgrupfili          = $row['CDGRUPFILI'];
        $idutretiprat        = $row['reportName'] == 'CUS01604' ? 'S' : 'T';
        $row['DTPERIINIC']   = $dtInicial;
        $row['DTPERIFINA']   = $dtFinal;
        $row['NRCONSPLAN']   = $nrConsPlan;
        $row['NRORG']        = $this->environment->getNrOrg();
        
        $listaFili = '_' . implode('_', $row['LISTACDFILIAL']) . '_';
        $nrListaFili = $this->util->insertLista($row['LISTACDFILIAL']);
        $row['LISTAFILI'] = $nrListaFili;
        
        $row['IDQUEBRAPAGINA'] = $row['QR2TYPE'] == 'PDF' ? 'N' : 'S';
        
        if($row['CDGRUPSERV'] != 'T'){
            $row['CDGRUPSERV'] = '_' . implode('_', $row['CDGRUPSERV']) . '_';
        }

       if($row['LISTAFILISERV'] == 'T'){
            $listaFiliServ = $this->cus01600DesvioDeConsumoService->getServico($row['NRLISTA'], $row['CDGRUPSERV'], $idutretiprat);
            $listaFiliServConcat = '_' . implode('_', $listaFiliServ) . '_';
            
            $nrListaServ = $this->util->insertLista($listaFiliServ);
            $nrListaServBIRT = $this->util->insertLista($listaFiliServ);
            $row['LISTASERV'] = $nrListaServBIRT;
            
        } else {
            $listaFiliServConcat = '_' . implode('_', $row['LISTAFILISERV']) . '_';
            $nrListaServ = $this->util->insertLista($row['LISTAFILISERV']);
            
            if($row['CDSERVFILI'] != 'T'){
               $row['LISTASERV'] = $listaFiliServConcat;
            }
        }
        
        /*ToDo: Foreach registros cdfilial e cdservfili; Concatenar registros na forma 
        999900001_; Utilizar função getServico() do service para pegar registros dentro
        do grupo de serviços; Definir parâmetros na row para utilização no relatório.*/
        $procedure = new StoredProcedure($this->connection, 'CONSPLAN_GERAL');
        $procedure->addParam(new Param('P_NRLISTA',      Param::PARAM_INPUT,  $nrListaServ,             Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTINICIAL',    Param::PARAM_INPUT,  $dtInicial,           Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL',      Param::PARAM_INPUT,  $dtFinal,             Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDPRODUTOS',   Param::PARAM_INPUT,  $idProdutos,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDSEPPRATO',   Param::PARAM_INPUT,  $idSepPratos,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_PEACRESCIMO',  Param::PARAM_INPUT,  $peAcrescimo,         Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param('P_IDARREDOND',   Param::PARAM_INPUT,  $idArredond,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODUTOINI', Param::PARAM_INPUT,  $cdProdutoIni,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODUTOFIN', Param::PARAM_INPUT,  $row['CDPRODFINA'],   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT,  $cdOperador,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRCONSPLANTH', Param::PARAM_INPUT,  $nrConsPlan,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRCONSPLAN',   Param::PARAM_OUTPUT, null,                 Param::PARAM_TYPE_NULL));
        
        
        $resultProcedure = $procedure->execute(); 
        $row['NRCONSPLAN'] = $resultProcedure['P_NRCONSPLAN'];
        $row['NRCONSPLAN'] = $nrConsPlan;
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    } 
    
    public function insertLista(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $cdOperador = $this->environment->getCdOperador();

        if($row['LISTACDFILIAL'] === 'T'){
            $row['LISTACDFILIAL'] = $this->cus01600DesvioDeConsumoService->getFilial($cdOperador, $row['CDGRUPFILI']);
        }
        
        $nrLista = $this->util->insertLista($row['LISTACDFILIAL']);
        $dataSet = array(
		    'NRLISTA' => $nrLista,
		    'LISTACDFILIAL' => $row['LISTACDFILIAL']
		);
        $response->addDataSet(new DataSet('data', $dataSet));
        
    } 
    
    public function deleteLista(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $nrLista = $this->util->deleteLista($row['NRLISTA']);
    } 
}